{$A-,B-,D-,E-,F-,G+,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-}
{$M 16384,0,655360}
(*)-- Pascal Support ----------------------------------------------
   Demo by Victor Shantar [2:5054/26@fidonet]
-------------------------------------- http://attend.to/virgi --(*)
Uses MyCrt;

type tscreen=array[0..199,0..319] of byte;
     simb=array[1..20,1..8] of byte;
     SinTabType = Array[0..2047] of Integer;
     SinTabPtr  = ^SinTabType;

     pWaterDemo=^tWaterDemo;
     tWaterDemo=Object
       SinTab                       : SinTabPtr;
       Ang1,Ang2                    : Integer;
       Px,Py,Height                 : Integer;
       Constructor Init;
       Procedure SetupSinTab; virtual;
       Procedure DrawRipples; virtual;
       Procedure Next; virtual;
       Destructor Done; virtual;
     end;

Const
   SinTabSize                   = 1024;
   SinTabAmp                    = 128;

Var OutBuffer:^tscreen;
    video:tscreen absolute $A000:0;


Constructor tWaterDemo.Init;
begin
  New(SinTab);
  SetupSinTab;
  DrawRipples;
end;

Procedure tWaterDemo.SetupSinTab;
Var
   n                            : Integer;
   a,ast                        : Real;
Begin
   a:=0;
   ast:=2*pi/SinTabSize;
   For n:=0 to SinTabSize-1 do
   Begin
      SinTab^[n]:=Round(128*Sin(a));
      a:=a+ast
   End
End;

Procedure tWaterDemo.DrawRipples;
Begin
   Ang1:=0;
   Ang2:=0;
end;

Procedure tWaterDemo.Next;
var z,x:integer;
begin
   FillChar(OutBuffer^,64000,200);
   For z:=-30 to -10 do
      For x:=-20 to 20 do
      Begin
         Height:=
                 SinTab^[(Ang1+x*32) and (SinTabSize-1)]+
                 SinTab^[(Ang2+z*32) and (SinTabSize-1)];
         Px:=64*x div z;
         Py:=(Height+240) div z;
         OutBuffer^[99-py,159+px]:=31-((height+256) div 64);
   End;
   Ang1:=Ang1+17;
   Ang1:=Ang1 and (SinTabSize-1);
   Ang2:=Ang2+12;
   Ang2:=Ang2 and (SinTabSize-1)
End;

Destructor tWaterDemo.Done;
begin
  dispose(SinTab);
end;

{-----------------------------------------------------------------------}

Procedure OpenRegs; near; assembler;
Asm
  cli
  mov dx,03C4h
  mov ax,0402h
  out dx,ax
  mov ax,0704h
  out dx,ax
  mov dl,0CEh
  mov ax,0204h
  out dx,ax
  mov ax,0005h
  out dx,ax
  mov ax,0406h
  out dx,ax
End;

Procedure CloseRegs; near; assembler;
Asm
  mov dx,03C4h
  mov ax,0302h
  out dx,ax
  mov ax,0304h
  out dx,ax
  mov dl,0CEh
  mov ax,0004h
  out dx,ax
  mov ax,1005h
  out dx,ax
  mov es,Seg0040
  mov ax,0E06h
  cmp byte ptr es:[0049h],07h
  jne @color
  mov ax,0A06h
@color:
  out dx,ax
  sti
End;

Procedure SaveCharset(var Buffer; StartChar, Count, ScanLines : word); assembler;
Asm
  call OpenRegs
  push ds
  mov ax,SegA000
  mov ds,ax
  mov ax,StartChar
  mov bx,32
  mul bx
  mov si,ax
  les di,Buffer
  cld
  mov ax,Count
  mul bx
  mov dx,ScanLines
@@1:
  mov cx,dx
  rep movsb
  mov cx,bx
  sub cx,dx
  add si,cx
  sub ax,bx
  cmp ax,0
  jnz @@1
  pop ds
  call CloseRegs
End;


var font:array[0..255] of simb;

Procedure ReadFont;
type tchar=array[1..16] of byte;
var i,j:byte; char_:tchar;

Function dec2bin(l:longint):string;
var i:byte; j:longint; s:string;
begin
  s:=''; j:=1; if l=0 then s:='00000000';
  while j<=l do begin
    if l and j=j then s:='1'+s else s:='0'+s;
    j:=2*j;
  end;
  while s[0]<#8 do s:='0'+s;
  dec2bin:=s;
end;

var s:string; k:byte;

begin
  randomize;
  for i:=0 to 255 do begin
    SaveCharSet(char_,i,1,16);
    for j:=1 to 20 do begin
      if j<17 then s:=dec2bin(char_[j]) else s:='00000000';
      for k:=1 to 8 do begin
        if s[k]='1' then begin
          font[i,j,k]:=251+j div 4;
          if k>1 then if (s[k-1]='0') and (j div 4<2) then
            font[i,j,k]:=251
          else else if j div 4<2 then font[i,j,k]:=251;
        end else begin
          font[i,j,k]:=0;
          if (j>1) and (font[i,j-1,k]<>0) then if random(j div 2)=0 then
            font[i,j,k]:=252;
        end;
      end;
    end;
  end;
end;

Procedure SetRGBColor(c,r,g,b:byte);
begin
  port[$3C8]:=c;
  port[$3C9]:=r;
  port[$3C9]:=g;
  port[$3C9]:=b;
end;

Procedure GetRGBColor(c,r,g,b:byte);
begin
  port[$3C8]:=c;
  port[$3C9]:=r;
  port[$3C9]:=g;
  port[$3C9]:=b;
end;

Procedure PutChar(x,y:word; c:char;var where:tscreen);
var i,j:byte; cc:byte; a,b:word;
begin
  cc:=byte(c);
  for i:=1 to 20 do begin
    a:=y+i-1; if (a>=0) and (a<200) then
      for j:=1 to 8 do begin
        b:=x+j-1; if (b>=0) and (b<299) then where[y+i-1,x+j-1]:=font[cc,i,j];
      end;
  end;
end;

Procedure PutString(x,y:word; s:string;var where:tscreen);
var r:byte;
begin
  for r:=1 to length(s) do PutChar(x+(r-1)*8,y,s[r],where);
end;

Procedure Flip(var from_, to_:tscreen);
var a,b:word;
begin
  a:=seg(from_);
  b:=seg(to_);
asm
  push ds
  mov ds,a
  mov es,b
  xor si,si
  xor di,di
  mov cx,16000
  db 66h; rep movsw
  pop ds
end;
end;

Procedure PutPic(X: Word;Y:Byte;VAR sprt;W,H:word;Where:Word); ASSEMBLER;
  {W=ਭ, H=, Sprt=ࠩ (ᨢ 祪) }
label
  _Redraw, _DrawLoop, _Exit, _LineLoop, _NextLine, _Ignore;

asm
    push  ds
    and   bl, 0
    mov   es, where   {  ᥣ⭮  Where  ES:DI}
    lds   si, Sprt    { ⥭  ࠩ  DS:SI }
    mov   di, x

    {᫥୨ ᬥ饭 (y*320)+x}
    mov   bh, y       { bx = y*256 }
    mov   ax, bx      {   Y }
    shr   ax, 2       { y2 = y2 * 64}
    add   bx, ax      {  ᬥ饭 : y = y1+y2 (y=y*320) }
    add   di, bx      { 쭮 ᬥ饭 (Y*320)+X }

    cld
    and   ch, 0
    mov   ax,H        {  AX  }

_DrawLoop:
    mov   dx,di        { ࠭ ᬥ饭   ᯮ짮 }
    mov   cx,W       {  CX ਭ }
_LineLoop:
    mov   bl,byte ptr [si]
    or    bl,bl       { ஢ઠ   }
    jz    _Ignore     { ᫨ ,  㥬 }
    movsb
    loop   _LineLoop
    jmp    _NextLine

_Ignore:
    inc    si
    inc    di
    loop  _LineLoop

_NextLine:
    mov   di,dx
    dec   ax           {   }
    jz    _Exit
    add   di,140h
    jmp   _DrawLoop

_Exit:
    pop   ds
end;

Procedure FlipZero(var where1,where2:tscreen);
begin
  PutPic(0,0,where1,320,200,seg(where2));
end;


var buff:^tscreen; s:string;
    i,j:byte; c:char; m:pWaterDemo;

Const mtext:array[1..5] of string[40] = (
  'Welcome to HEDGEHOG HOUSE',
  '  Phone: +7-3422-622044',
  'Time: 00:00 - 07:30 Local',
  '  SysOp: Victor Shantar',
  '   (2:5054/26@FidoNet)');

var mmt:array[1..5] of string[40];

begin
  s:=mtext[5];
  mmt[1]:='ttt';
  new(OutBuffer);
  mmt[2]:='tt@tbZnR\PPnXPPT\\';
  readfont;
  mmt[3]:='@tTT@TTtntTZ@RTt';
  new(buff); fillchar(buff^,64000,0);
  mmt[4]:='ttҪ@tt';
  SetRgbColor(251,48,17,17);
  SetRgbColor(252,40,10,10);
  SetRgbColor(253,40,8,8);
  SetRgbColor(254,35,6,6);
  mmt[5]:='tttdP@^T^\jPXf';
  asm mov ax,13h; int 10h end;
  new(m,init);
  repeat
    m^.next;

    For I:=1 to 5 do begin
      s:='';
      For j:=1 to length(mmt[i]) do s:=s+chr( (ord(mmt[i,j]) shr 1) xor 26);
      PutString(60,I*20+30,s,buff^);
    end;

    FlipZero(buff^,outbuffer^);
    Flip(outbuffer^,video);
  until keypressed;
  dispose(m,done);
  asm mov ax,3; int 10h end;
  dispose(buff);
  dispose(OutBuffer);
  writeln('THiS iNTR0 C0DED BY ViCT0R SHANTAR');
  i:=readkey;
end.